package gi;

public class AndNode extends Symbol {
	public OrNode left, right;

	public AndNode(OrNode left, OrNode right, int appNum) {
		this.left = left;
		this.right = right;
		this.appearanceNum = appNum;
		// left.parent=right.parent=this;
		left.parents.add(this);
		right.parents.add(this);
	}

	@Override
	public String toString() {
		StringBuilder content = new StringBuilder(Integer
				.toHexString(hashCode())
				+ "([");
		for (Symbol s : left.children) {
			if (s instanceof Term)
				content.append(s);
			else
				content.append(Integer.toHexString(s.hashCode()));
			content.append(", ");
		}
		content.delete(content.length() - 2, content.length());
		content.append("][");
		for (Symbol s : right.children) {
			if (s instanceof Term)
				content.append(s);
			else
				content.append(Integer.toHexString(s.hashCode()));
			content.append(", ");
		}
		content.delete(content.length() - 2, content.length());
		content.append("])");
		return content.toString();
	}
}
