package gi;

import java.util.ArrayList;

public class OrNode {
	public ArrayList<Symbol> children;

	/**
	 * The weight of a child node should be the number of appearance of the
	 * child node that represents this OR node in the corpus. In other words,
	 * it's the number of times the child node being under this OR node in all
	 * the parsing trees of the corpus.
	 */
	public ArrayList<double[]> weights;

	// public AndNode parent;
	public ArrayList<AndNode> parents = new ArrayList<AndNode>();

	public OrNode(ArrayList<Symbol> children, ArrayList<double[]> weights) {
		this.children = children;
		this.weights = weights;
		for (Symbol chld : children) {
			chld.parents.add(this);
		}
	}

	/**
	 * Decrease the weight of the "s" child by 1. If then its weight becomes 0,
	 * delete the child.
	 * 
	 * @param s
	 */
	public void decreaseChildWeight(Symbol s) {
		int ind = children.indexOf(s);
		double i = weights.get(ind)[0];
		if (i == 1) {
			children.remove(ind);
			weights.remove(ind);
			s.parents.remove(this);
		} else {
			weights.get(ind)[0]--;
		}
	}

	@Override
	public String toString() {
		return children.toString();
	}
}
